package sun.net.www.protocol.http;

import java.net.URISyntaxException;
import java.net.URI;
import sun.net.www.HeaderParser;
import java.net.URL;
import java.util.Base64;
import java.io.UnsupportedEncodingException;
import java.net.PasswordAuthentication;

class BasicAuthentication extends AuthenticationInfo
{
    private static final long serialVersionUID = 100L;
    String auth;
    
    public BasicAuthentication(boolean b, String s, int n, String s2, PasswordAuthentication pw) {
        super(b ? 'p' : 's', AuthScheme.BASIC, s, n, s2);
        String string = pw.getUserName() + ":";
        byte[] bytes = null;
        try {
            bytes = string.getBytes("ISO-8859-1");
        }
        catch (UnsupportedEncodingException ex) {
            assert false;
        }
        char[] password = pw.getPassword();
        byte[] array = new byte[password.length];
        for (int i = 0; i < password.length; ++i) {
            array[i] = (byte)password[i];
        }
        byte[] src = new byte[bytes.length + array.length];
        System.arraycopy(bytes, 0, src, 0, bytes.length);
        System.arraycopy(array, 0, src, bytes.length, array.length);
        this.auth = "Basic " + Base64.getEncoder().encodeToString(src);
        this.pw = pw;
    }
    
    public BasicAuthentication(boolean b, String s, int n, String s2, String str) {
        super(b ? 'p' : 's', AuthScheme.BASIC, s, n, s2);
        this.auth = "Basic " + str;
    }
    
    public BasicAuthentication(boolean b, URL url, String s, PasswordAuthentication pw) {
        super(b ? 'p' : 's', AuthScheme.BASIC, url, s);
        String string = pw.getUserName() + ":";
        byte[] bytes = null;
        try {
            bytes = string.getBytes("ISO-8859-1");
        }
        catch (UnsupportedEncodingException ex) {
            assert false;
        }
        char[] password = pw.getPassword();
        byte[] array = new byte[password.length];
        for (int i = 0; i < password.length; ++i) {
            array[i] = (byte)password[i];
        }
        byte[] src = new byte[bytes.length + array.length];
        System.arraycopy(bytes, 0, src, 0, bytes.length);
        System.arraycopy(array, 0, src, bytes.length, array.length);
        this.auth = "Basic " + Base64.getEncoder().encodeToString(src);
        this.pw = pw;
    }
    
    public BasicAuthentication(boolean b, URL url, String s, String str) {
        super(b ? 'p' : 's', AuthScheme.BASIC, url, s);
        this.auth = "Basic " + str;
    }
    
    @Override
    public boolean supportsPreemptiveAuthorization() {
        return true;
    }
    
    @Override
    public boolean setHeaders(HttpURLConnection httpURLConnection, HeaderParser headerParser, String s) {
        httpURLConnection.setAuthenticationProperty(this.getHeaderName(), this.getHeaderValue(null, null));
        return true;
    }
    
    @Override
    public String getHeaderValue(URL url, String s) {
        return this.auth;
    }
    
    @Override
    public boolean isAuthorizationStale(String s) {
        return false;
    }
    
    static String getRootPath(String path, String path2) {
        int i = 0;
        try {
            path = new URI(path).normalize().getPath();
            path2 = new URI(path2).normalize().getPath();
        }
        catch (URISyntaxException ex) {}
        while (i < path2.length()) {
            int index = path2.indexOf(47, i + 1);
            if (index != -1 && path2.regionMatches(0, path, 0, index + 1)) {
                i = index;
            }
            else {
                return path2.substring(0, i + 1);
            }
        }
        return path;
    }
}
